import { MotionValue } from "../../value";
export declare const resolvePoses: (pose?: string | string[] | MotionValue<any> | undefined) => string[];
/**
 * Hooks in React sometimes accept a dependency array as their final argument. (ie useEffect/useMemo)
 * When values in this array change, React re-runs the dependency. However if the array
 * contains a variable number of items, React throws an error.
 */
export declare const asDependencyList: (list: string[]) => string[];
