/**
 * `useViewportScroll` provides `MotionValue`s that update when the viewport scrolls.
 *
 * This makes it possible to transform viewport scroll into other values.
 *
 * For instance, highlighting different table of contents items to correspond with page scroll.
 */
export declare const useViewportScrollValues: () => {
    scrollX: import(".").MotionValue<number>;
    scrollY: import(".").MotionValue<number>;
    scrollXProgress: import(".").MotionValue<number>;
    scrollYProgress: import(".").MotionValue<number>;
};
